OpenVDB: LeafNode< T, Log2Dim > Class Template Reference

OpenVDB 4.0.2

Classes | Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Types | Protected Member Functions | Static Protected Member Functions | Friends | List of all members
LeafNode< T, Log2Dim > Class Template Reference

Templated block class to hold specific data types and a fixed number of values determined by Log2Dim. The actual coordinate dimension of the block is 2^Log2Dim, i.e. Log2Dim=3 corresponds to a LeafNode that spans a 8^3 block. More...

`#include <LeafNode.h>`

Inherited by PointDataLeafNode< T, Log2Dim >, and PointIndexLeafNode< T, Log2Dim >.

## Classes
struct | ChildAll
struct | ChildIter
| Leaf nodes have no children, so their child iterators have no get/set accessors. More...
struct | ChildOff
struct | ChildOn
struct | DenseIter
struct | SameConfiguration
| SameConfiguration<OtherNodeType>::value is `true` if and only if OtherNodeType is the type of a LeafNode with the same dimensions as this node. More...
struct | ValueAll
struct | ValueConverter
| ValueConverter<T>::Type is the type of a LeafNode having the same dimensions as this node but a different value type, T. More...
struct | ValueIter
struct | ValueOff
struct | ValueOn

## Public Types
using | BuildType = T
using | ValueType = T
using | Buffer = LeafBuffer< ValueType, Log2Dim >
using | LeafNodeType = LeafNode< ValueType, Log2Dim >
using | NodeMaskType = util::NodeMask< Log2Dim >
using | Ptr = SharedPtr< LeafNode >
using | ValueOnIter = ValueIter< MaskOnIterator, LeafNode, const ValueType, ValueOn >
using | ValueOnCIter = ValueIter< MaskOnIterator, const LeafNode, const ValueType, ValueOn >
using | ValueOffIter = ValueIter< MaskOffIterator, LeafNode, const ValueType, ValueOff >
using | ValueOffCIter = ValueIter< MaskOffIterator, const LeafNode, const ValueType, ValueOff >
using | ValueAllIter = ValueIter< MaskDenseIterator, LeafNode, const ValueType, ValueAll >
using | ValueAllCIter = ValueIter< MaskDenseIterator, const LeafNode, const ValueType, ValueAll >
using | ChildOnIter = ChildIter< MaskOnIterator, LeafNode, ChildOn >
using | ChildOnCIter = ChildIter< MaskOnIterator, const LeafNode, ChildOn >
using | ChildOffIter = ChildIter< MaskOffIterator, LeafNode, ChildOff >
using | ChildOffCIter = ChildIter< MaskOffIterator, const LeafNode, ChildOff >
using | ChildAllIter = DenseIter< LeafNode, ValueType, ChildAll >
using | ChildAllCIter = DenseIter< const LeafNode, const ValueType, ChildAll >

## Public Member Functions
| LeafNode ()
| Default constructor. More...
| LeafNode (const Coord &coords, const ValueType &value=zeroVal< ValueType >(), bool active=false)
| Constructor. More...
| LeafNode (PartialCreate, const Coord &coords, const ValueType &value=zeroVal< ValueType >(), bool active=false)
| "Partial creation" constructor used during file input More...
| LeafNode (const LeafNode &)
| Deep copy constructor. More...
LeafNode & | operator= (const LeafNode &)=default
| Deep assignment operator. More...
template<typename OtherValueType >
| LeafNode (const LeafNode< OtherValueType, Log2Dim > &other)
| Value conversion copy constructor. More...
template<typename OtherValueType >
| LeafNode (const LeafNode< OtherValueType, Log2Dim > &other, const ValueType &offValue, const ValueType &onValue, TopologyCopy)
| Topology copy constructor. More...
template<typename OtherValueType >
| LeafNode (const LeafNode< OtherValueType, Log2Dim > &other, const ValueType &background, TopologyCopy)
| Topology copy constructor. More...
| ~LeafNode ()
| Destructor. More...
Index64 | onVoxelCount () const
| Return the number of voxels marked On. More...
Index64 | offVoxelCount () const
| Return the number of voxels marked Off. More...
Index64 | onLeafVoxelCount () const
Index64 | offLeafVoxelCount () const
bool | isEmpty () const
| Return `true` if this node has no active voxels. More...
bool | isDense () const
| Return `true` if this node contains only active voxels. More...
bool | isAllocated () const
| Return `true` if memory for this node's buffer has been allocated. More...
bool | allocate ()
| Allocate memory for this node's buffer if it has not already been allocated. More...
Index64 | memUsage () const
| Return the memory in bytes occupied by this node. More...
void | evalActiveBoundingBox (CoordBBox &bbox, bool visitVoxels=true) const
CoordBBox | getNodeBoundingBox () const
| Return the bounding box of this node, i.e., the full index space spanned by this leaf node. More...
void | setOrigin (const Coord &origin)
| Set the grid index coordinates of this node's local origin. More...
Coord | offsetToGlobalCoord (Index n) const
| Return the global coordinates for a linear table offset. More...
std::string | str () const
| Return a string representation of this node. More...
template<typename OtherType , Index OtherLog2Dim>
bool | hasSameTopology (const LeafNode< OtherType, OtherLog2Dim > *other) const
| Return `true` if the given node (which may have a different `ValueType` than this node) has the same active value topology as this node. More...
bool | operator== (const LeafNode &other) const
| Check for buffer, state and origin equivalence. More...
bool | operator!= (const LeafNode &other) const
ValueOnCIter | cbeginValueOn () const
ValueOnCIter | beginValueOn () const
ValueOnIter | beginValueOn ()
ValueOffCIter | cbeginValueOff () const
ValueOffCIter | beginValueOff () const
ValueOffIter | beginValueOff ()
ValueAllCIter | cbeginValueAll () const
ValueAllCIter | beginValueAll () const
ValueAllIter | beginValueAll ()
ValueOnCIter | cendValueOn () const
ValueOnCIter | endValueOn () const
ValueOnIter | endValueOn ()
ValueOffCIter | cendValueOff () const
ValueOffCIter | endValueOff () const
ValueOffIter | endValueOff ()
ValueAllCIter | cendValueAll () const
ValueAllCIter | endValueAll () const
ValueAllIter | endValueAll ()
ChildOnCIter | cbeginChildOn () const
ChildOnCIter | beginChildOn () const
ChildOnIter | beginChildOn ()
ChildOffCIter | cbeginChildOff () const
ChildOffCIter | beginChildOff () const
ChildOffIter | beginChildOff ()
ChildAllCIter | cbeginChildAll () const
ChildAllCIter | beginChildAll () const
ChildAllIter | beginChildAll ()
ChildOnCIter | cendChildOn () const
ChildOnCIter | endChildOn () const
ChildOnIter | endChildOn ()
ChildOffCIter | cendChildOff () const
ChildOffCIter | endChildOff () const
ChildOffIter | endChildOff ()
ChildAllCIter | cendChildAll () const
ChildAllCIter | endChildAll () const
ChildAllIter | endChildAll ()
void | swap (Buffer &other)
| Exchange this node's data buffer with the given data buffer without changing the active states of the values. More...
const Buffer & | buffer () const
Buffer & | buffer ()
void | readTopology (std::istream &is, bool fromHalf=false)
| Read in just the topology. More...
void | writeTopology (std::ostream &os, bool toHalf=false) const
| Write out just the topology. More...
void | readBuffers (std::istream &is, bool fromHalf=false)
| Read buffers from a stream. More...
void | readBuffers (std::istream &is, const CoordBBox &bbox, bool fromHalf=false)
| Read buffers that intersect the given bounding box. More...
void | writeBuffers (std::ostream &os, bool toHalf=false) const
| Write buffers to a stream. More...
size_t | streamingSize (bool toHalf=false) const
const ValueType & | getValue (const Coord &xyz) const
| Return the value of the voxel at the given coordinates. More...
const ValueType & | getValue (Index offset) const
| Return the value of the voxel at the given linear offset. More...
bool | probeValue (const Coord &xyz, ValueType &val) const
| Return `true` if the voxel at the given coordinates is active. More...
bool | probeValue (Index offset, ValueType &val) const
| Return `true` if the voxel at the given offset is active. More...
void | setActiveState (const Coord &xyz, bool on)
| Set the active state of the voxel at the given coordinates but don't change its value. More...
void | setActiveState (Index offset, bool on)
| Set the active state of the voxel at the given offset but don't change its value. More...
void | setValueOnly (const Coord &xyz, const ValueType &val)
| Set the value of the voxel at the given coordinates but don't change its active state. More...
void | setValueOnly (Index offset, const ValueType &val)
| Set the value of the voxel at the given offset but don't change its active state. More...
void | setValueOff (const Coord &xyz)
| Mark the voxel at the given coordinates as inactive but don't change its value. More...
void | setValueOff (Index offset)
| Mark the voxel at the given offset as inactive but don't change its value. More...
void | setValueOff (const Coord &xyz, const ValueType &val)
| Set the value of the voxel at the given coordinates and mark the voxel as inactive. More...
void | setValueOff (Index offset, const ValueType &val)
| Set the value of the voxel at the given offset and mark the voxel as inactive. More...
void | setValueOn (const Coord &xyz)
| Mark the voxel at the given coordinates as active but don't change its value. More...
void | setValueOn (Index offset)
| Mark the voxel at the given offset as active but don't change its value. More...
void | setValueOn (const Coord &xyz, const ValueType &val)
| Set the value of the voxel at the given coordinates and mark the voxel as active. More...
void | setValue (const Coord &xyz, const ValueType &val)
| Set the value of the voxel at the given coordinates and mark the voxel as active. More...
void | setValueOn (Index offset, const ValueType &val)
| Set the value of the voxel at the given offset and mark the voxel as active. More...
template<typename ModifyOp >
void | modifyValue (Index offset, const ModifyOp &op)
| Apply a functor to the value of the voxel at the given offset and mark the voxel as active. More...
template<typename ModifyOp >
void | modifyValue (const Coord &xyz, const ModifyOp &op)
| Apply a functor to the value of the voxel at the given coordinates and mark the voxel as active. More...
template<typename ModifyOp >
void | modifyValueAndActiveState (const Coord &xyz, const ModifyOp &op)
| Apply a functor to the voxel at the given coordinates. More...
void | setValuesOn ()
| Mark all voxels as active but don't change their values. More...
void | setValuesOff ()
| Mark all voxels as inactive but don't change their values. More...
bool | isValueOn (const Coord &xyz) const
| Return `true` if the voxel at the given coordinates is active. More...
bool | isValueOn (Index offset) const
| Return `true` if the voxel at the given offset is active. More...
void | clip (const CoordBBox &, const ValueType &background)
| Set all voxels that lie outside the given axis-aligned box to the background. More...
void | fill (const CoordBBox &bbox, const ValueType &, bool active=true)
| Set all voxels within an axis-aligned box to the specified value and active state. More...
void | denseFill (const CoordBBox &bbox, const ValueType &value, bool active=true)
| Set all voxels within an axis-aligned box to the specified value and active state. More...
void | fill (const ValueType &value)
| Set all voxels to the specified value but don't change their active states. More...
void | fill (const ValueType &value, bool active)
| Set all voxels to the specified value and active state. More...
template<typename DenseT >
void | copyToDense (const CoordBBox &bbox, DenseT &dense) const
| Copy into a dense grid the values of the voxels that lie within a given bounding box. More...
template<typename DenseT >
void | copyFromDense (const CoordBBox &bbox, const DenseT &dense, const ValueType &background, const ValueType &tolerance)
| Copy from a dense grid into this node the values of the voxels that lie within a given bounding box. More...
template<typename AccessorT >
const ValueType & | getValueAndCache (const Coord &xyz, AccessorT &) const
| Return the value of the voxel at the given coordinates. More...
template<typename AccessorT >
bool | isValueOnAndCache (const Coord &xyz, AccessorT &) const
| Return `true` if the voxel at the given coordinates is active. More...
template<typename AccessorT >
void | setValueAndCache (const Coord &xyz, const ValueType &val, AccessorT &)
| Change the value of the voxel at the given coordinates and mark it as active. More...
template<typename AccessorT >
void | setValueOnlyAndCache (const Coord &xyz, const ValueType &val, AccessorT &)
| Change the value of the voxel at the given coordinates but preserve its state. More...
template<typename ModifyOp , typename AccessorT >
void | modifyValueAndCache (const Coord &xyz, const ModifyOp &op, AccessorT &)
| Apply a functor to the value of the voxel at the given coordinates and mark the voxel as active. More...
template<typename ModifyOp , typename AccessorT >
void | modifyValueAndActiveStateAndCache (const Coord &xyz, const ModifyOp &op, AccessorT &)
template<typename AccessorT >
void | setValueOffAndCache (const Coord &xyz, const ValueType &value, AccessorT &)
| Change the value of the voxel at the given coordinates and mark it as inactive. More...
template<typename AccessorT >
void | setActiveStateAndCache (const Coord &xyz, bool on, AccessorT &)
| Set the active state of the voxel at the given coordinates without changing its value. More...
template<typename AccessorT >
bool | probeValueAndCache (const Coord &xyz, ValueType &val, AccessorT &) const
| Return `true` if the voxel at the given coordinates is active and return the voxel value in val. More...
template<typename AccessorT >
const ValueType & | getValue (const Coord &xyz, bool &state, int &level, AccessorT &) const
| Return the value of the voxel at the given coordinates and return its active state and level (i.e., 0) in state and level. More...
const ValueType & | getFirstValue () const
| Return a const reference to the first value in the buffer. More...
const ValueType & | getLastValue () const
| Return a const reference to the last value in the buffer. More...
void | resetBackground (const ValueType &oldBackground, const ValueType &newBackground)
| Replace inactive occurrences of oldBackground with newBackground, and inactive occurrences of -oldBackground with -newBackground. More...
void | negate ()
void | voxelizeActiveTiles (bool=true)
| No-op. More...
template<MergePolicy Policy>
void | merge (const LeafNode &)
template<MergePolicy Policy>
void | merge (const ValueType &tileValue, bool tileActive)
template<MergePolicy Policy>
void | merge (const LeafNode &other, const ValueType &, const ValueType &)
template<typename OtherType >
void | topologyUnion (const LeafNode< OtherType, Log2Dim > &other)
| Union this node's set of active values with the active values of the other node, whose `ValueType` may be different. So a resulting voxel will be active if either of the original voxels were active. More...
template<typename OtherType >
void | topologyIntersection (const LeafNode< OtherType, Log2Dim > &other, const ValueType &)
| Intersect this node's set of active values with the active values of the other node, whose `ValueType` may be different. So a resulting voxel will be active only if both of the original voxels were active. More...
template<typename OtherType >
void | topologyDifference (const LeafNode< OtherType, Log2Dim > &other, const ValueType &)
| Difference this node's set of active values with the active values of the other node, whose `ValueType` may be different. So a resulting voxel will be active only if the original voxel is active in this LeafNode and inactive in the other LeafNode. More...
template<typename CombineOp >
void | combine (const LeafNode &other, CombineOp &op)
template<typename CombineOp >
void | combine (const ValueType &value, bool valueIsActive, CombineOp &op)
template<typename CombineOp , typename OtherType >
void | combine2 (const LeafNode &other, const OtherType &, bool valueIsActive, CombineOp &)
template<typename CombineOp , typename OtherNodeT >
void | combine2 (const ValueType &, const OtherNodeT &other, bool valueIsActive, CombineOp &)
template<typename CombineOp , typename OtherNodeT >
void | combine2 (const LeafNode &b0, const OtherNodeT &b1, CombineOp &)
template<typename BBoxOp >
void | visitActiveBBox (BBoxOp &) const
| Calls the templated functor BBoxOp with bounding box information. An additional level argument is provided to the callback. More...
template<typename VisitorOp >
void | visit (VisitorOp &)
template<typename VisitorOp >
void | visit (VisitorOp &) const
template<typename OtherLeafNodeType , typename VisitorOp >
void | visit2Node (OtherLeafNodeType &other, VisitorOp &)
template<typename OtherLeafNodeType , typename VisitorOp >
void | visit2Node (OtherLeafNodeType &other, VisitorOp &) const
template<typename IterT , typename VisitorOp >
void | visit2 (IterT &otherIter, VisitorOp &, bool otherIsLHS=false)
template<typename IterT , typename VisitorOp >
void | visit2 (IterT &otherIter, VisitorOp &, bool otherIsLHS=false) const
void | addTile (Index level, const Coord &, const ValueType &, bool)
void | addTile (Index offset, const ValueType &, bool)
template<typename AccessorT >
void | addTileAndCache (Index, const Coord &, const ValueType &, bool, AccessorT &)
bool | isConstant (ValueType &firstValue, bool &state, const ValueType &tolerance=zeroVal< ValueType >()) const
bool | isConstant (ValueType &minValue, ValueType &maxValue, bool &state, const ValueType &tolerance=zeroVal< ValueType >()) const
ValueType | medianAll (ValueType *tmp=nullptr) const
| Computes the median value of all the active AND inactive voxels in this node. More...
Index | medianOn (ValueType &value, ValueType *tmp=nullptr) const
| Computes the median value of all the active voxels in this node. More...
Index | medianOff (ValueType &value, ValueType *tmp=nullptr) const
| Computes the median value of all the inactive voxels in this node. More...
bool | isInactive () const
| Return `true` if all of this node's values are inactive. More...
bool | isValueMaskOn (Index n) const
bool | isValueMaskOn () const
bool | isValueMaskOff (Index n) const
bool | isValueMaskOff () const
const NodeMaskType & | getValueMask () const
NodeMaskType & | getValueMask ()
const NodeMaskType & | valueMask () const
void | setValueMask (const NodeMaskType &mask)
bool | isChildMaskOn (Index) const
bool | isChildMaskOff (Index) const
bool | isChildMaskOff () const
const Coord & | origin () const
| Return the grid index coordinates of this node's local origin. More...
void | getOrigin (Coord &origin) const
| Return the grid index coordinates of this node's local origin. More...
void | getOrigin (Int32 &x, Int32 &y, Int32 &z) const
| Return the grid index coordinates of this node's local origin. More...
void | prune (const ValueType &=zeroVal< ValueType >())
| This function exists only to enable template instantiation. More...
void | addLeaf (LeafNode *)
| This function exists only to enable template instantiation. More...
template<typename AccessorT >
void | addLeafAndCache (LeafNode *, AccessorT &)
| This function exists only to enable template instantiation. More...
template<typename NodeT >
NodeT * | stealNode (const Coord &, const ValueType &, bool)
| This function exists only to enable template instantiation. More...
template<typename NodeT >
NodeT * | probeNode (const Coord &)
| This function exists only to enable template instantiation. More...
template<typename NodeT >
const NodeT * | probeConstNode (const Coord &) const
| This function exists only to enable template instantiation. More...
template<typename ArrayT >
void | getNodes (ArrayT &) const
| This function exists only to enable template instantiation. More...
template<typename ArrayT >
void | stealNodes (ArrayT &, const ValueType &, bool)
| This function exists only to enable template instantiation. More...
LeafNode * | touchLeaf (const Coord &)
| Return a pointer to this node. More...
template<typename AccessorT >
LeafNode * | touchLeafAndCache (const Coord &, AccessorT &)
| Return a pointer to this node. More...
template<typename NodeT , typename AccessorT >
NodeT * | probeNodeAndCache (const Coord &, AccessorT &)
| Return a pointer to this node. More...
LeafNode * | probeLeaf (const Coord &)
| Return a pointer to this node. More...
template<typename AccessorT >
LeafNode * | probeLeafAndCache (const Coord &, AccessorT &)
| Return a pointer to this node. More...
const LeafNode * | probeConstLeaf (const Coord &) const
| Return a `const` pointer to this node. More...
template<typename AccessorT >
const LeafNode * | probeConstLeafAndCache (const Coord &, AccessorT &) const
| Return a `const` pointer to this node. More...
template<typename AccessorT >
const LeafNode * | probeLeafAndCache (const Coord &, AccessorT &) const
| Return a `const` pointer to this node. More...
const LeafNode * | probeLeaf (const Coord &) const
| Return a `const` pointer to this node. More...
template<typename NodeT , typename AccessorT >
const NodeT * | probeConstNodeAndCache (const Coord &, AccessorT &) const
| Return a `const` pointer to this node. More...

## Static Public Member Functions
static Index | log2dim ()
| Return log2 of the dimension of this LeafNode, e.g. 3 if dimensions are 8^3. More...
static Index | dim ()
| Return the number of voxels in each coordinate dimension. More...
static Index | size ()
| Return the total number of voxels represented by this LeafNode. More...
static Index | numValues ()
| Return the total number of voxels represented by this LeafNode. More...
static Index | getLevel ()
| Return the level of this node, which by definition is zero for LeafNodes. More...
static void | getNodeLog2Dims (std::vector< Index > &dims)
| Append the Log2Dim of this LeafNode to the specified vector. More...
static Index | getChildDim ()
| Return the dimension of child nodes of this LeafNode, which is one for voxels. More...
static Index32 | leafCount ()
| Return the leaf count for this node, which is one. More...
static Index32 | nonLeafCount ()
| Return the non-leaf count for this node, which is zero. More...
static Index64 | onTileCount ()
static Index64 | offTileCount ()
static Index | coordToOffset (const Coord &xyz)
| Return the linear table offset of the given global or local coordinates. More...
static Coord | offsetToLocalCoord (Index n)
| Return the local coordinates for a linear table offset, where offset 0 has coordinates (0, 0, 0). More...
static Index | getValueLevel (const Coord &)
| Return the level (i.e., 0) at which leaf node values reside. More...
static bool | hasActiveTiles ()
| Return `false` since leaf nodes never contain tiles. More...
template<typename AccessorT >
static Index | getValueLevelAndCache (const Coord &, AccessorT &)
| Return the LEVEL (=0) at which leaf node values reside. More...

## Static Public Attributes
static const Index | LOG2DIM = Log2Dim
static const Index | TOTAL = Log2Dim
static const Index | DIM = 1 << TOTAL
static const Index | NUM_VALUES = 1 << 3 * Log2Dim
static const Index | NUM_VOXELS = NUM_VALUES
static const Index | SIZE = NUM_VALUES
static const Index | LEVEL = 0

## Protected Types
using | MaskOnIterator = typename NodeMaskType::OnIterator
using | MaskOffIterator = typename NodeMaskType::OffIterator
using | MaskDenseIterator = typename NodeMaskType::DenseIterator

## Protected Member Functions
void | setValueMask (Index n, bool on)
void | setValueMaskOn (Index n)
void | setValueMaskOff (Index n)
void | skipCompressedValues (bool seekable, std::istream &, bool fromHalf)

## Static Protected Member Functions
static void | evalNodeOrigin (Coord &xyz)
| Compute the origin of the leaf node that contains the voxel with the given coordinates. More...
template<typename NodeT , typename VisitorOp , typename ChildAllIterT >
static void | doVisit (NodeT &, VisitorOp &)
template<typename NodeT , typename OtherNodeT , typename VisitorOp , typename ChildAllIterT , typename OtherChildAllIterT >
static void | doVisit2Node (NodeT &self, OtherNodeT &other, VisitorOp &)
template<typename NodeT , typename VisitorOp , typename ChildAllIterT , typename OtherChildAllIterT >
static void | doVisit2 (NodeT &self, OtherChildAllIterT &, VisitorOp &, bool otherIsLHS)

## Friends
class | ::TestLeaf
template<typename >
class | ::TestLeafIO
template<typename , Index >
class | LeafNode
struct | ValueIter< MaskOnIterator, LeafNode, ValueType, ValueOn >
struct | ValueIter< MaskOffIterator, LeafNode, ValueType, ValueOff >
struct | ValueIter< MaskDenseIterator, LeafNode, ValueType, ValueAll >
struct | ValueIter< MaskOnIterator, const LeafNode, ValueType, ValueOn >
struct | ValueIter< MaskOffIterator, const LeafNode, ValueType, ValueOff >
struct | ValueIter< MaskDenseIterator, const LeafNode, ValueType, ValueAll >
class | IteratorBase< MaskOnIterator, LeafNode >
class | IteratorBase< MaskOffIterator, LeafNode >
class | IteratorBase< MaskDenseIterator, LeafNode >

## Detailed Description

### template<typename T, Index Log2Dim>
class openvdb::v4_0_2::tree::LeafNode< T, Log2Dim >

Templated block class to hold specific data types and a fixed number of values determined by Log2Dim. The actual coordinate dimension of the block is 2^Log2Dim, i.e. Log2Dim=3 corresponds to a LeafNode that spans a 8^3 block.

## Member Typedef Documentation

## ◆ Buffer

using Buffer = LeafBuffer<ValueType, Log2Dim>

## ◆ BuildType

using BuildType = T

## ◆ ChildAllCIter

using ChildAllCIter = DenseIter<const LeafNode, const ValueType, ChildAll>

## ◆ ChildAllIter

using ChildAllIter = DenseIter<LeafNode, ValueType, ChildAll>

## ◆ ChildOffCIter

using ChildOffCIter = ChildIter<MaskOffIterator, const LeafNode, ChildOff>

## ◆ ChildOffIter

using ChildOffIter = ChildIter<MaskOffIterator, LeafNode, ChildOff>

## ◆ ChildOnCIter

using ChildOnCIter = ChildIter<MaskOnIterator, const LeafNode, ChildOn>

## ◆ ChildOnIter

using ChildOnIter = ChildIter<MaskOnIterator, LeafNode, ChildOn>

## ◆ LeafNodeType

using LeafNodeType = LeafNode<ValueType, Log2Dim>

## ◆ MaskDenseIterator

using MaskDenseIterator = typename NodeMaskType::DenseIterator
| protected

## ◆ MaskOffIterator

using MaskOffIterator = typename NodeMaskType::OffIterator
| protected

## ◆ MaskOnIterator

using MaskOnIterator = typename NodeMaskType::OnIterator
| protected

## ◆ NodeMaskType

using NodeMaskType = util::NodeMask<Log2Dim>

## ◆ Ptr

using Ptr = SharedPtr<LeafNode>

## ◆ ValueAllCIter

using ValueAllCIter = ValueIter<MaskDenseIterator,const LeafNode,const ValueType,ValueAll>

## ◆ ValueAllIter

using ValueAllIter = ValueIter<MaskDenseIterator, LeafNode, const ValueType, ValueAll>

## ◆ ValueOffCIter

using ValueOffCIter = ValueIter<MaskOffIterator,const LeafNode,const ValueType,ValueOff>

## ◆ ValueOffIter

using ValueOffIter = ValueIter<MaskOffIterator, LeafNode, const ValueType, ValueOff>

## ◆ ValueOnCIter

using ValueOnCIter = ValueIter<MaskOnIterator, const LeafNode, const ValueType, ValueOn>

## ◆ ValueOnIter

using ValueOnIter = ValueIter<MaskOnIterator, LeafNode, const ValueType, ValueOn>

## ◆ ValueType

using ValueType = T

## Constructor & Destructor Documentation

## ◆ LeafNode() [1/7]

LeafNode | ( |  | ) |
| inline

Default constructor.

## ◆ LeafNode() [2/7]

LeafNode | ( | const Coord & | coords,
|  | const ValueType & | value = `zeroVal<ValueType>()`,
|  | bool | active = `false`
| ) |  |
| inlineexplicit

Constructor.

Parameters

  coords | the grid index coordinates of a voxel
  value | a value with which to fill the buffer
  active | the active state to which to initialize all voxels

## ◆ LeafNode() [3/7]

LeafNode | ( | PartialCreate | ,
|  | const Coord & | coords,
|  | const ValueType & | value = `zeroVal<ValueType>()`,
|  | bool | active = `false`
| ) |  |
| inline

"Partial creation" constructor used during file input

Parameters

  coords | the grid index coordinates of a voxel
  value | a value with which to fill the buffer
  active | the active state to which to initialize all voxels

This constructor does not allocate memory for voxel values.

## ◆ LeafNode() [4/7]

LeafNode | ( | const LeafNode< T, Log2Dim > & | other | ) |
| inline

Deep copy constructor.

## ◆ LeafNode() [5/7]

LeafNode | ( | const LeafNode< OtherValueType, Log2Dim > & | other | ) |
| inlineexplicit

Value conversion copy constructor.

## ◆ LeafNode() [6/7]

LeafNode | ( | const LeafNode< OtherValueType, Log2Dim > & | other,
|  | const ValueType & | offValue,
|  | const ValueType & | onValue,
|  | TopologyCopy |
| ) |  |
| inline

Topology copy constructor.

## ◆ LeafNode() [7/7]

LeafNode | ( | const LeafNode< OtherValueType, Log2Dim > & | other,
|  | const ValueType & | background,
|  | TopologyCopy |
| ) |  |
| inline

Topology copy constructor.

## ◆ ~LeafNode()

~LeafNode | ( |  | ) |
| inline

Destructor.

## Member Function Documentation

## ◆ addLeaf()

void addLeaf | ( | LeafNode< T, Log2Dim > * |  | ) |
| inline

This function exists only to enable template instantiation.

## ◆ addLeafAndCache()

void addLeafAndCache | ( | LeafNode< T, Log2Dim > * | ,
|  | AccessorT & |
| ) |  |
| inline

This function exists only to enable template instantiation.

## ◆ addTile() [1/2]

void addTile | ( | Index | level,
|  | const Coord & | xyz,
|  | const ValueType & | val,
|  | bool | active
| ) |  |
| inline

## ◆ addTile() [2/2]

void addTile | ( | Index | offset,
|  | const ValueType & | val,
|  | bool | active
| ) |  |
| inline

## ◆ addTileAndCache()

void addTileAndCache | ( | Index | level,
|  | const Coord & | xyz,
|  | const ValueType & | val,
|  | bool | active,
|  | AccessorT & |
| ) |  |
| inline

## ◆ allocate()

bool allocate | ( |  | ) |
| inline

Allocate memory for this node's buffer if it has not already been allocated.

## ◆ beginChildAll() [1/2]

ChildAllCIter beginChildAll | ( |  | ) | const
| inline

## ◆ beginChildAll() [2/2]

ChildAllIter beginChildAll | ( |  | ) |
| inline

## ◆ beginChildOff() [1/2]

ChildOffCIter beginChildOff | ( |  | ) | const
| inline

## ◆ beginChildOff() [2/2]

ChildOffIter beginChildOff | ( |  | ) |
| inline

## ◆ beginChildOn() [1/2]

ChildOnCIter beginChildOn | ( |  | ) | const
| inline

## ◆ beginChildOn() [2/2]

ChildOnIter beginChildOn | ( |  | ) |
| inline

## ◆ beginValueAll() [1/2]

ValueAllCIter beginValueAll | ( |  | ) | const
| inline

## ◆ beginValueAll() [2/2]

ValueAllIter beginValueAll | ( |  | ) |
| inline

## ◆ beginValueOff() [1/2]

ValueOffCIter beginValueOff | ( |  | ) | const
| inline

## ◆ beginValueOff() [2/2]

ValueOffIter beginValueOff | ( |  | ) |
| inline

## ◆ beginValueOn() [1/2]

ValueOnCIter beginValueOn | ( |  | ) | const
| inline

## ◆ beginValueOn() [2/2]

ValueOnIter beginValueOn | ( |  | ) |
| inline

## ◆ buffer() [1/2]

const Buffer& buffer | ( |  | ) | const
| inline

## ◆ buffer() [2/2]

Buffer& buffer | ( |  | ) |
| inline

## ◆ cbeginChildAll()

ChildAllCIter cbeginChildAll | ( |  | ) | const
| inline

## ◆ cbeginChildOff()

ChildOffCIter cbeginChildOff | ( |  | ) | const
| inline

## ◆ cbeginChildOn()

ChildOnCIter cbeginChildOn | ( |  | ) | const
| inline

## ◆ cbeginValueAll()

ValueAllCIter cbeginValueAll | ( |  | ) | const
| inline

## ◆ cbeginValueOff()

ValueOffCIter cbeginValueOff | ( |  | ) | const
| inline

## ◆ cbeginValueOn()

ValueOnCIter cbeginValueOn | ( |  | ) | const
| inline

## ◆ cendChildAll()

ChildAllCIter cendChildAll | ( |  | ) | const
| inline

## ◆ cendChildOff()

ChildOffCIter cendChildOff | ( |  | ) | const
| inline

## ◆ cendChildOn()

ChildOnCIter cendChildOn | ( |  | ) | const
| inline

## ◆ cendValueAll()

ValueAllCIter cendValueAll | ( |  | ) | const
| inline

## ◆ cendValueOff()

ValueOffCIter cendValueOff | ( |  | ) | const
| inline

## ◆ cendValueOn()

ValueOnCIter cendValueOn | ( |  | ) | const
| inline

## ◆ clip()

void clip | ( | const CoordBBox & | clipBBox,
|  | const ValueType & | background
| ) |  |
| inline

Set all voxels that lie outside the given axis-aligned box to the background.

## ◆ combine() [1/2]

void combine | ( | const LeafNode< T, Log2Dim > & | other,
|  | CombineOp & | op
| ) |  |
| inline

## ◆ combine() [2/2]

void combine | ( | const ValueType & | value,
|  | bool | valueIsActive,
|  | CombineOp & | op
| ) |  |
| inline

## ◆ combine2() [1/3]

void combine2 | ( | const LeafNode< T, Log2Dim > & | other,
|  | const OtherType & | value,
|  | bool | valueIsActive,
|  | CombineOp & | op
| ) |  |
| inline

## ◆ combine2() [2/3]

void combine2 | ( | const ValueType & | value,
|  | const OtherNodeT & | other,
|  | bool | valueIsActive,
|  | CombineOp & | op
| ) |  |
| inline

## ◆ combine2() [3/3]

void combine2 | ( | const LeafNode< T, Log2Dim > & | b0,
|  | const OtherNodeT & | b1,
|  | CombineOp & | op
| ) |  |
| inline

## ◆ coordToOffset()

Index coordToOffset | ( | const Coord & | xyz | ) |
| inlinestatic

Return the linear table offset of the given global or local coordinates.

## ◆ copyFromDense()

void copyFromDense | ( | const CoordBBox & | bbox,
|  | const DenseT & | dense,
|  | const ValueType & | background,
|  | const ValueType & | tolerance
| ) |  |
| inline

Copy from a dense grid into this node the values of the voxels that lie within a given bounding box.

Only values that are different (by more than the given tolerance) from the background value will be active. Other values are inactive and truncated to the background value.

Parameters

  bbox | inclusive bounding box of the voxels to be copied into this node
  dense | dense grid with a stride in z of one (see tools::Dense in tools/Dense.h for the required API)
  background | background value of the tree that this node belongs to
  tolerance | tolerance within which a value equals the background value

Note
  bbox is assumed to be identical to or contained in the coordinate domains of both the dense grid and this node, i.e., no bounds checking is performed.
  Consider using tools::CopyFromDense in tools/Dense.h instead of calling this method directly.

## ◆ copyToDense()

void copyToDense | ( | const CoordBBox & | bbox,
|  | DenseT & | dense
| ) |  | const
| inline

Copy into a dense grid the values of the voxels that lie within a given bounding box.

Parameters

  bbox | inclusive bounding box of the voxels to be copied into the dense grid
  dense | dense grid with a stride in z of one (see tools::Dense in tools/Dense.h for the required API)

Note
  bbox is assumed to be identical to or contained in the coordinate domains of both the dense grid and this node, i.e., no bounds checking is performed.
  Consider using tools::CopyToDense in tools/Dense.h instead of calling this method directly.

## ◆ denseFill()

void denseFill | ( | const CoordBBox & | bbox,
|  | const ValueType & | value,
|  | bool | active = `true`
| ) |  |
| inline

Set all voxels within an axis-aligned box to the specified value and active state.

## ◆ dim()

static Index dim | ( |  | ) |
| inlinestatic

Return the number of voxels in each coordinate dimension.

## ◆ doVisit()

void doVisit | ( | NodeT & | self,
|  | VisitorOp & | op
| ) |  |
| inlinestaticprotected

## ◆ doVisit2()

void doVisit2 | ( | NodeT & | self,
|  | OtherChildAllIterT & | otherIter,
|  | VisitorOp & | op,
|  | bool | otherIsLHS
| ) |  |
| inlinestaticprotected

## ◆ doVisit2Node()

void doVisit2Node | ( | NodeT & | self,
|  | OtherNodeT & | other,
|  | VisitorOp & | op
| ) |  |
| inlinestaticprotected

## ◆ endChildAll() [1/2]

ChildAllCIter endChildAll | ( |  | ) | const
| inline

## ◆ endChildAll() [2/2]

ChildAllIter endChildAll | ( |  | ) |
| inline

## ◆ endChildOff() [1/2]

ChildOffCIter endChildOff | ( |  | ) | const
| inline

## ◆ endChildOff() [2/2]

ChildOffIter endChildOff | ( |  | ) |
| inline

## ◆ endChildOn() [1/2]

ChildOnCIter endChildOn | ( |  | ) | const
| inline

## ◆ endChildOn() [2/2]

ChildOnIter endChildOn | ( |  | ) |
| inline

## ◆ endValueAll() [1/2]

ValueAllCIter endValueAll | ( |  | ) | const
| inline

## ◆ endValueAll() [2/2]

ValueAllIter endValueAll | ( |  | ) |
| inline

## ◆ endValueOff() [1/2]

ValueOffCIter endValueOff | ( |  | ) | const
| inline

## ◆ endValueOff() [2/2]

ValueOffIter endValueOff | ( |  | ) |
| inline

## ◆ endValueOn() [1/2]

ValueOnCIter endValueOn | ( |  | ) | const
| inline

## ◆ endValueOn() [2/2]

ValueOnIter endValueOn | ( |  | ) |
| inline

## ◆ evalActiveBoundingBox()

void evalActiveBoundingBox | ( | CoordBBox & | bbox,
|  | bool | visitVoxels = `true`
| ) |  | const
| inline

Expand the given bounding box so that it includes this leaf node's active voxels. If visitVoxels is false this LeafNode will be approximated as dense, i.e. with all voxels active. Else the individual active voxels are visited to produce a tight bbox.

## ◆ evalNodeOrigin()

static void evalNodeOrigin | ( | Coord & | xyz | ) |
| inlinestaticprotected

Compute the origin of the leaf node that contains the voxel with the given coordinates.

## ◆ fill() [1/3]

void fill | ( | const CoordBBox & | bbox,
|  | const ValueType & | value,
|  | bool | active = `true`
| ) |  |
| inline

Set all voxels within an axis-aligned box to the specified value and active state.

## ◆ fill() [2/3]

void fill | ( | const ValueType & | value | ) |
| inline

Set all voxels to the specified value but don't change their active states.

## ◆ fill() [3/3]

void fill | ( | const ValueType & | value,
|  | bool | active
| ) |  |
| inline

Set all voxels to the specified value and active state.

## ◆ getChildDim()

static Index getChildDim | ( |  | ) |
| inlinestatic

Return the dimension of child nodes of this LeafNode, which is one for voxels.

## ◆ getFirstValue()

const ValueType& getFirstValue | ( |  | ) | const
| inline

Return a const reference to the first value in the buffer.

Note
  Though it is potentially risky you can convert this to a non-const pointer by means of const_case<ValueType*>&.

## ◆ getLastValue()

const ValueType& getLastValue | ( |  | ) | const
| inline

Return a const reference to the last value in the buffer.

## ◆ getLevel()

static Index getLevel | ( |  | ) |
| inlinestatic

Return the level of this node, which by definition is zero for LeafNodes.

## ◆ getNodeBoundingBox()

CoordBBox getNodeBoundingBox | ( |  | ) | const
| inline

Return the bounding box of this node, i.e., the full index space spanned by this leaf node.

## ◆ getNodeLog2Dims()

static void getNodeLog2Dims | ( | std::vector< Index > & | dims | ) |
| inlinestatic

Append the Log2Dim of this LeafNode to the specified vector.

## ◆ getNodes()

void getNodes | ( | ArrayT & |  | ) | const
| inline

This function exists only to enable template instantiation.

## ◆ getOrigin() [1/2]

void getOrigin | ( | Coord & | origin | ) | const
| inline

Return the grid index coordinates of this node's local origin.

## ◆ getOrigin() [2/2]

void getOrigin | ( | Int32 & | x,
|  | Int32 & | y,
|  | Int32 & | z
| ) |  | const
| inline

Return the grid index coordinates of this node's local origin.

## ◆ getValue() [1/3]

const ValueT & getValue | ( | const Coord & | xyz | ) | const
| inline

Return the value of the voxel at the given coordinates.

## ◆ getValue() [2/3]

const ValueT & getValue | ( | Index | offset | ) | const
| inline

Return the value of the voxel at the given linear offset.

## ◆ getValue() [3/3]

const ValueType& getValue | ( | const Coord & | xyz,
|  | bool & | state,
|  | int & | level,
|  | AccessorT & |
| ) |  | const
| inline

Return the value of the voxel at the given coordinates and return its active state and level (i.e., 0) in state and level.

Note
  Used internally by ValueAccessor.

## ◆ getValueAndCache()

const ValueType& getValueAndCache | ( | const Coord & | xyz,
|  | AccessorT & |
| ) |  | const
| inline

Return the value of the voxel at the given coordinates.

Note
  Used internally by ValueAccessor.

## ◆ getValueLevel()

static Index getValueLevel | ( | const Coord & |  | ) |
| inlinestatic

Return the level (i.e., 0) at which leaf node values reside.

## ◆ getValueLevelAndCache()

static Index getValueLevelAndCache | ( | const Coord & | ,
|  | AccessorT & |
| ) |  |
| inlinestatic

Return the LEVEL (=0) at which leaf node values reside.

Note
  Used internally by ValueAccessor (note last argument is a dummy).

## ◆ getValueMask() [1/2]

const NodeMaskType& getValueMask | ( |  | ) | const
| inline

## ◆ getValueMask() [2/2]

NodeMaskType& getValueMask | ( |  | ) |
| inline

## ◆ hasActiveTiles()

static bool hasActiveTiles | ( |  | ) |
| inlinestatic

Return `false` since leaf nodes never contain tiles.

## ◆ hasSameTopology()

bool hasSameTopology | ( | const LeafNode< OtherType, OtherLog2Dim > * | other | ) | const
| inline

Return `true` if the given node (which may have a different `ValueType` than this node) has the same active value topology as this node.

## ◆ isAllocated()

bool isAllocated | ( |  | ) | const
| inline

Return `true` if memory for this node's buffer has been allocated.

## ◆ isChildMaskOff() [1/2]

bool isChildMaskOff | ( | Index |  | ) | const
| inline

## ◆ isChildMaskOff() [2/2]

bool isChildMaskOff | ( |  | ) | const
| inline

## ◆ isChildMaskOn()

bool isChildMaskOn | ( | Index |  | ) | const
| inline

## ◆ isConstant() [1/2]

bool isConstant | ( | ValueType & | firstValue,
|  | bool & | state,
|  | const ValueType & | tolerance = `zeroVal<ValueType>()`
| ) |  | const
| inline

Return `true` if all of this node's values have the same active state and are in the range this->getFirstValue() +/- tolerance.

Parameters

  firstValue | Is updated with the first value of this leaf node.
  state | Is updated with the state of all values IF method returns `true`. Else the value is undefined!
  tolerance | The tolerance used to determine if values are approximatly equal to the for value.

## ◆ isConstant() [2/2]

bool isConstant | ( | ValueType & | minValue,
|  | ValueType & | maxValue,
|  | bool & | state,
|  | const ValueType & | tolerance = `zeroVal<ValueType>()`
| ) |  | const
| inline

Return `true` if all of this node's values have the same active state and the range (maxValue - minValue) < tolerance.

Parameters

  minValue | Is updated with the minimum of all values IF method returns `true`. Else the value is undefined!
  maxValue | Is updated with the maximum of all values IF method returns `true`. Else the value is undefined!
  state | Is updated with the state of all values IF method returns `true`. Else the value is undefined!
  tolerance | The tolerance used to determine if values are approximatly constant.

## ◆ isDense()

bool isDense | ( |  | ) | const
| inline

Return `true` if this node contains only active voxels.

## ◆ isEmpty()

bool isEmpty | ( |  | ) | const
| inline

Return `true` if this node has no active voxels.

## ◆ isInactive()

bool isInactive | ( |  | ) | const
| inline

Return `true` if all of this node's values are inactive.

## ◆ isValueMaskOff() [1/2]

bool isValueMaskOff | ( | Index | n | ) | const
| inline

## ◆ isValueMaskOff() [2/2]

bool isValueMaskOff | ( |  | ) | const
| inline

## ◆ isValueMaskOn() [1/2]

bool isValueMaskOn | ( | Index | n | ) | const
| inline

## ◆ isValueMaskOn() [2/2]

bool isValueMaskOn | ( |  | ) | const
| inline

## ◆ isValueOn() [1/2]

bool isValueOn | ( | const Coord & | xyz | ) | const
| inline

Return `true` if the voxel at the given coordinates is active.

## ◆ isValueOn() [2/2]

bool isValueOn | ( | Index | offset | ) | const
| inline

Return `true` if the voxel at the given offset is active.

## ◆ isValueOnAndCache()

bool isValueOnAndCache | ( | const Coord & | xyz,
|  | AccessorT & |
| ) |  | const
| inline

Return `true` if the voxel at the given coordinates is active.

Note
  Used internally by ValueAccessor.

## ◆ leafCount()

static Index32 leafCount | ( |  | ) |
| inlinestatic

Return the leaf count for this node, which is one.

## ◆ log2dim()

static Index log2dim | ( |  | ) |
| inlinestatic

Return log2 of the dimension of this LeafNode, e.g. 3 if dimensions are 8^3.

## ◆ medianAll()

T medianAll | ( | ValueType * | tmp = `nullptr` | ) | const
| inline

Computes the median value of all the active AND inactive voxels in this node.

Returns
  The median value of all values in this node.

Parameters

  tmp | Optional temporary storage that can hold at least NUM_VALUES values Use of this temporary storage can improve performance when this method is called multiple times.

Note
  If tmp = this->buffer().data() then the median value is computed very efficiently (in place) but the voxel values in this node are re-shuffeled!

Warning
  If tmp != nullptr then it is the responsibility of the client code that it points to enough memory to hold NUM_VALUES elements of type ValueType.

## ◆ medianOff()

Index medianOff | ( | ValueType & | value,
|  | ValueType * | tmp = `nullptr`
| ) |  | const
| inline

Computes the median value of all the inactive voxels in this node.

Returns
  The number of inactive voxels.

Parameters

  value | If the return value is non zero value is updated with the median value.
  tmp | Optional temporary storage that can hold at least as many values as there are inactive voxels in this node. Use of this temporary storage can improve performance when this method is called multiple times.

Warning
  If tmp != nullptr then it is the responsibility of the client code that it points to enough memory to hold the number of inactive voxels of type ValueType.

## ◆ medianOn()

Index medianOn | ( | ValueType & | value,
|  | ValueType * | tmp = `nullptr`
| ) |  | const
| inline

Computes the median value of all the active voxels in this node.

Returns
  The number of active voxels.

Parameters

  value | If the return value is non zero value is updated with the median value.
  tmp | Optional temporary storage that can hold at least as many values as there are active voxels in this node. Use of this temporary storage can improve performance when this method is called multiple times.

Warning
  If tmp != nullptr then it is the responsibility of the client code that it points to enough memory to hold the number of active voxels of type ValueType.

## ◆ memUsage()

Index64 memUsage | ( |  | ) | const
| inline

Return the memory in bytes occupied by this node.

## ◆ merge() [1/3]

void merge | ( | const LeafNode< T, Log2Dim > & | other | ) |
| inline

## ◆ merge() [2/3]

void merge | ( | const ValueType & | tileValue,
|  | bool | tileActive
| ) |  |
| inline

## ◆ merge() [3/3]

void merge | ( | const LeafNode< T, Log2Dim > & | other,
|  | const ValueType & | ,
|  | const ValueType & |
| ) |  |
| inline

## ◆ modifyValue() [1/2]

void modifyValue | ( | Index | offset,
|  | const ModifyOp & | op
| ) |  |
| inline

Apply a functor to the value of the voxel at the given offset and mark the voxel as active.

## ◆ modifyValue() [2/2]

void modifyValue | ( | const Coord & | xyz,
|  | const ModifyOp & | op
| ) |  |
| inline

Apply a functor to the value of the voxel at the given coordinates and mark the voxel as active.

## ◆ modifyValueAndActiveState()

void modifyValueAndActiveState | ( | const Coord & | xyz,
|  | const ModifyOp & | op
| ) |  |
| inline

Apply a functor to the voxel at the given coordinates.

## ◆ modifyValueAndActiveStateAndCache()

void modifyValueAndActiveStateAndCache | ( | const Coord & | xyz,
|  | const ModifyOp & | op,
|  | AccessorT & |
| ) |  |
| inline

Apply a functor to the voxel at the given coordinates.

Note
  Used internally by ValueAccessor.

## ◆ modifyValueAndCache()

void modifyValueAndCache | ( | const Coord & | xyz,
|  | const ModifyOp & | op,
|  | AccessorT & |
| ) |  |
| inline

Apply a functor to the value of the voxel at the given coordinates and mark the voxel as active.

Note
  Used internally by ValueAccessor.

## ◆ negate()

void negate | ( |  | ) |
| inline

## ◆ nonLeafCount()

static Index32 nonLeafCount | ( |  | ) |
| inlinestatic

Return the non-leaf count for this node, which is zero.

## ◆ numValues()

static Index numValues | ( |  | ) |
| inlinestatic

Return the total number of voxels represented by this LeafNode.

## ◆ offLeafVoxelCount()

Index64 offLeafVoxelCount | ( |  | ) | const
| inline

## ◆ offsetToGlobalCoord()

Coord offsetToGlobalCoord | ( | Index | n | ) | const
| inline

Return the global coordinates for a linear table offset.

## ◆ offsetToLocalCoord()

Coord offsetToLocalCoord | ( | Index | n | ) |
| inlinestatic

Return the local coordinates for a linear table offset, where offset 0 has coordinates (0, 0, 0).

## ◆ offTileCount()

static Index64 offTileCount | ( |  | ) |
| inlinestatic

## ◆ offVoxelCount()

Index64 offVoxelCount | ( |  | ) | const
| inline

Return the number of voxels marked Off.

## ◆ onLeafVoxelCount()

Index64 onLeafVoxelCount | ( |  | ) | const
| inline

## ◆ onTileCount()

static Index64 onTileCount | ( |  | ) |
| inlinestatic

## ◆ onVoxelCount()

Index64 onVoxelCount | ( |  | ) | const
| inline

Return the number of voxels marked On.

## ◆ operator!=()

bool operator!= | ( | const LeafNode< T, Log2Dim > & | other | ) | const
| inline

## ◆ operator=()

LeafNode& operator= | ( | const LeafNode< T, Log2Dim > & |  | ) |
| default

Deep assignment operator.

## ◆ operator==()

bool operator== | ( | const LeafNode< T, Log2Dim > & | other | ) | const
| inline

Check for buffer, state and origin equivalence.

## ◆ origin()

const Coord& origin | ( |  | ) | const
| inline

Return the grid index coordinates of this node's local origin.

## ◆ probeConstLeaf()

const LeafNode* probeConstLeaf | ( | const Coord & |  | ) | const
| inline

Return a `const` pointer to this node.

## ◆ probeConstLeafAndCache()

const LeafNode* probeConstLeafAndCache | ( | const Coord & | ,
|  | AccessorT & |
| ) |  | const
| inline

Return a `const` pointer to this node.

## ◆ probeConstNode()

const NodeT* probeConstNode | ( | const Coord & |  | ) | const
| inline

This function exists only to enable template instantiation.

## ◆ probeConstNodeAndCache()

const NodeT* probeConstNodeAndCache | ( | const Coord & | ,
|  | AccessorT & |
| ) |  | const
| inline

Return a `const` pointer to this node.

## ◆ probeLeaf() [1/2]

LeafNode* probeLeaf | ( | const Coord & |  | ) |
| inline

Return a pointer to this node.

## ◆ probeLeaf() [2/2]

const LeafNode* probeLeaf | ( | const Coord & |  | ) | const
| inline

Return a `const` pointer to this node.

## ◆ probeLeafAndCache() [1/2]

LeafNode* probeLeafAndCache | ( | const Coord & | ,
|  | AccessorT & |
| ) |  |
| inline

Return a pointer to this node.

## ◆ probeLeafAndCache() [2/2]

const LeafNode* probeLeafAndCache | ( | const Coord & | ,
|  | AccessorT & |
| ) |  | const
| inline

Return a `const` pointer to this node.

## ◆ probeNode()

NodeT* probeNode | ( | const Coord & |  | ) |
| inline

This function exists only to enable template instantiation.

## ◆ probeNodeAndCache()

NodeT* probeNodeAndCache | ( | const Coord & | ,
|  | AccessorT & |
| ) |  |
| inline

Return a pointer to this node.

## ◆ probeValue() [1/2]

bool probeValue | ( | const Coord & | xyz,
|  | ValueType & | val
| ) |  | const
| inline

Return `true` if the voxel at the given coordinates is active.

Parameters

  | xyz | the coordinates of the voxel to be probed
  [out] | val | the value of the voxel at the given coordinates

## ◆ probeValue() [2/2]

bool probeValue | ( | Index | offset,
|  | ValueType & | val
| ) |  | const
| inline

Return `true` if the voxel at the given offset is active.

Parameters

  | offset | the linear offset of the voxel to be probed
  [out] | val | the value of the voxel at the given coordinates

## ◆ probeValueAndCache()

bool probeValueAndCache | ( | const Coord & | xyz,
|  | ValueType & | val,
|  | AccessorT & |
| ) |  | const
| inline

Return `true` if the voxel at the given coordinates is active and return the voxel value in val.

Note
  Used internally by ValueAccessor.

## ◆ prune()

void prune | ( | const ValueType & | = `zeroVal<ValueType>()` | ) |
| inline

This function exists only to enable template instantiation.

## ◆ readBuffers() [1/2]

void readBuffers | ( | std::istream & | is,
|  | bool | fromHalf = `false`
| ) |  |
| inline

Read buffers from a stream.

Parameters

  is | the stream from which to read
  fromHalf | if true, floating-point input values are assumed to be 16-bit

## ◆ readBuffers() [2/2]

void readBuffers | ( | std::istream & | is,
|  | const CoordBBox & | bbox,
|  | bool | fromHalf = `false`
| ) |  |
| inline

Read buffers that intersect the given bounding box.

Parameters

  is | the stream from which to read
  bbox | an index-space bounding box
  fromHalf | if true, floating-point input values are assumed to be 16-bit

## ◆ readTopology()

void readTopology | ( | std::istream & | is,
|  | bool | fromHalf = `false`
| ) |  |
| inline

Read in just the topology.

Parameters

  is | the stream from which to read
  fromHalf | if true, floating-point input values are assumed to be 16-bit

## ◆ resetBackground()

void resetBackground | ( | const ValueType & | oldBackground,
|  | const ValueType & | newBackground
| ) |  |
| inline

Replace inactive occurrences of oldBackground with newBackground, and inactive occurrences of -oldBackground with -newBackground.

## ◆ setActiveState() [1/2]

void setActiveState | ( | const Coord & | xyz,
|  | bool | on
| ) |  |
| inline

Set the active state of the voxel at the given coordinates but don't change its value.

## ◆ setActiveState() [2/2]

void setActiveState | ( | Index | offset,
|  | bool | on
| ) |  |
| inline

Set the active state of the voxel at the given offset but don't change its value.

## ◆ setActiveStateAndCache()

void setActiveStateAndCache | ( | const Coord & | xyz,
|  | bool | on,
|  | AccessorT & |
| ) |  |
| inline

Set the active state of the voxel at the given coordinates without changing its value.

Note
  Used internally by ValueAccessor.

## ◆ setOrigin()

void setOrigin | ( | const Coord & | origin | ) |
| inline

Set the grid index coordinates of this node's local origin.

## ◆ setValue()

void setValue | ( | const Coord & | xyz,
|  | const ValueType & | val
| ) |  |
| inline

Set the value of the voxel at the given coordinates and mark the voxel as active.

## ◆ setValueAndCache()

void setValueAndCache | ( | const Coord & | xyz,
|  | const ValueType & | val,
|  | AccessorT & |
| ) |  |
| inline

Change the value of the voxel at the given coordinates and mark it as active.

Note
  Used internally by ValueAccessor.

## ◆ setValueMask() [1/2]

void setValueMask | ( | const NodeMaskType & | mask | ) |
| inline

## ◆ setValueMask() [2/2]

void setValueMask | ( | Index | n,
|  | bool | on
| ) |  |
| inlineprotected

## ◆ setValueMaskOff()

void setValueMaskOff | ( | Index | n | ) |
| inlineprotected

## ◆ setValueMaskOn()

void setValueMaskOn | ( | Index | n | ) |
| inlineprotected

## ◆ setValueOff() [1/4]

void setValueOff | ( | const Coord & | xyz | ) |
| inline

Mark the voxel at the given coordinates as inactive but don't change its value.

## ◆ setValueOff() [2/4]

void setValueOff | ( | Index | offset | ) |
| inline

Mark the voxel at the given offset as inactive but don't change its value.

## ◆ setValueOff() [3/4]

void setValueOff | ( | const Coord & | xyz,
|  | const ValueType & | val
| ) |  |
| inline

Set the value of the voxel at the given coordinates and mark the voxel as inactive.

## ◆ setValueOff() [4/4]

void setValueOff | ( | Index | offset,
|  | const ValueType & | val
| ) |  |
| inline

Set the value of the voxel at the given offset and mark the voxel as inactive.

## ◆ setValueOffAndCache()

void setValueOffAndCache | ( | const Coord & | xyz,
|  | const ValueType & | value,
|  | AccessorT & |
| ) |  |
| inline

Change the value of the voxel at the given coordinates and mark it as inactive.

Note
  Used internally by ValueAccessor.

## ◆ setValueOn() [1/4]

void setValueOn | ( | const Coord & | xyz | ) |
| inline

Mark the voxel at the given coordinates as active but don't change its value.

## ◆ setValueOn() [2/4]

void setValueOn | ( | Index | offset | ) |
| inline

Mark the voxel at the given offset as active but don't change its value.

## ◆ setValueOn() [3/4]

void setValueOn | ( | const Coord & | xyz,
|  | const ValueType & | val
| ) |  |
| inline

Set the value of the voxel at the given coordinates and mark the voxel as active.

## ◆ setValueOn() [4/4]

void setValueOn | ( | Index | offset,
|  | const ValueType & | val
| ) |  |
| inline

Set the value of the voxel at the given offset and mark the voxel as active.

## ◆ setValueOnly() [1/2]

void setValueOnly | ( | const Coord & | xyz,
|  | const ValueType & | val
| ) |  |
| inline

Set the value of the voxel at the given coordinates but don't change its active state.

## ◆ setValueOnly() [2/2]

void setValueOnly | ( | Index | offset,
|  | const ValueType & | val
| ) |  |
| inline

Set the value of the voxel at the given offset but don't change its active state.

## ◆ setValueOnlyAndCache()

void setValueOnlyAndCache | ( | const Coord & | xyz,
|  | const ValueType & | val,
|  | AccessorT & |
| ) |  |
| inline

Change the value of the voxel at the given coordinates but preserve its state.

Note
  Used internally by ValueAccessor.

## ◆ setValuesOff()

void setValuesOff | ( |  | ) |
| inline

Mark all voxels as inactive but don't change their values.

## ◆ setValuesOn()

void setValuesOn | ( |  | ) |
| inline

Mark all voxels as active but don't change their values.

## ◆ size()

static Index size | ( |  | ) |
| inlinestatic

Return the total number of voxels represented by this LeafNode.

## ◆ skipCompressedValues()

void skipCompressedValues | ( | bool | seekable,
|  | std::istream & | is,
|  | bool | fromHalf
| ) |  |
| inlineprotected

## ◆ stealNode()

NodeT* stealNode | ( | const Coord & | ,
|  | const ValueType & | ,
|  | bool |
| ) |  |
| inline

This function exists only to enable template instantiation.

## ◆ stealNodes()

void stealNodes | ( | ArrayT & | ,
|  | const ValueType & | ,
|  | bool |
| ) |  |
| inline

This function exists only to enable template instantiation.

## ◆ str()

std::string str | ( |  | ) | const
| inline

Return a string representation of this node.

## ◆ streamingSize()

size_t streamingSize | ( | bool | toHalf = `false` | ) | const

## ◆ swap()

void swap | ( | Buffer & | other | ) |
| inline

Exchange this node's data buffer with the given data buffer without changing the active states of the values.

## ◆ topologyDifference()

void topologyDifference | ( | const LeafNode< OtherType, Log2Dim > & | other,
|  | const ValueType & |
| ) |  |
| inline

Difference this node's set of active values with the active values of the other node, whose `ValueType` may be different. So a resulting voxel will be active only if the original voxel is active in this LeafNode and inactive in the other LeafNode.

The last dummy argument is required to match the signature for InternalNode::topologyDifference.

Note
  This operation modifies only active states, not values. Also, because it can deactivate all of this node's voxels, consider subsequently calling prune.

## ◆ topologyIntersection()

void topologyIntersection | ( | const LeafNode< OtherType, Log2Dim > & | other,
|  | const ValueType & |
| ) |  |
| inline

Intersect this node's set of active values with the active values of the other node, whose `ValueType` may be different. So a resulting voxel will be active only if both of the original voxels were active.

The last dummy argument is required to match the signature for InternalNode::topologyIntersection.

Note
  This operation modifies only active states, not values. Also note that this operation can result in all voxels being inactive so consider subsequnetly calling prune.

## ◆ topologyUnion()

void topologyUnion | ( | const LeafNode< OtherType, Log2Dim > & | other | ) |
| inline

Union this node's set of active values with the active values of the other node, whose `ValueType` may be different. So a resulting voxel will be active if either of the original voxels were active.

Note
  This operation modifies only active states, not values.

## ◆ touchLeaf()

LeafNode* touchLeaf | ( | const Coord & |  | ) |
| inline

Return a pointer to this node.

## ◆ touchLeafAndCache()

LeafNode* touchLeafAndCache | ( | const Coord & | ,
|  | AccessorT & |
| ) |  |
| inline

Return a pointer to this node.

## ◆ valueMask()

const NodeMaskType& valueMask | ( |  | ) | const
| inline

## ◆ visit() [1/2]

void visit | ( | VisitorOp & | op | ) |
| inline

## ◆ visit() [2/2]

void visit | ( | VisitorOp & | op | ) | const
| inline

## ◆ visit2() [1/2]

void visit2 | ( | IterT & | otherIter,
|  | VisitorOp & | op,
|  | bool | otherIsLHS = `false`
| ) |  |
| inline

## ◆ visit2() [2/2]

void visit2 | ( | IterT & | otherIter,
|  | VisitorOp & | op,
|  | bool | otherIsLHS = `false`
| ) |  | const
| inline

## ◆ visit2Node() [1/2]

void visit2Node | ( | OtherLeafNodeType & | other,
|  | VisitorOp & | op
| ) |  |
| inline

## ◆ visit2Node() [2/2]

void visit2Node | ( | OtherLeafNodeType & | other,
|  | VisitorOp & | op
| ) |  | const
| inline

## ◆ visitActiveBBox()

void visitActiveBBox | ( | BBoxOp & | op | ) | const
| inline

Calls the templated functor BBoxOp with bounding box information. An additional level argument is provided to the callback.

Note
  The bounding boxes are guarenteed to be non-overlapping.

## ◆ voxelizeActiveTiles()

void voxelizeActiveTiles | ( | bool | = `true` | ) |
| inline

No-op.

This function exists only to enable template instantiation.

## ◆ writeBuffers()

void writeBuffers | ( | std::ostream & | os,
|  | bool | toHalf = `false`
| ) |  | const
| inline

Write buffers to a stream.

Parameters

  os | the stream to which to write
  toHalf | if true, output floating-point values as 16-bit half floats

## ◆ writeTopology()

void writeTopology | ( | std::ostream & | os,
|  | bool | toHalf = `false`
| ) |  | const
| inline

Write out just the topology.

Parameters

  os | the stream to which to write
  toHalf | if true, output floating-point values as 16-bit half floats

## Friends And Related Function Documentation

## ◆ ::TestLeaf

friend class ::TestLeaf
| friend

## ◆ ::TestLeafIO

friend class ::TestLeafIO
| friend

## ◆ IteratorBase< MaskDenseIterator, LeafNode >

friend class IteratorBase< MaskDenseIterator, LeafNode >
| friend

## ◆ IteratorBase< MaskOffIterator, LeafNode >

friend class IteratorBase< MaskOffIterator, LeafNode >
| friend

## ◆ IteratorBase< MaskOnIterator, LeafNode >

friend class IteratorBase< MaskOnIterator, LeafNode >
| friend

## ◆ LeafNode

friend class LeafNode
| friend

## ◆ ValueIter< MaskDenseIterator, const LeafNode, ValueType, ValueAll >

friend struct ValueIter< MaskDenseIterator, const LeafNode, ValueType, ValueAll >
| friend

## ◆ ValueIter< MaskDenseIterator, LeafNode, ValueType, ValueAll >

friend struct ValueIter< MaskDenseIterator, LeafNode, ValueType, ValueAll >
| friend

## ◆ ValueIter< MaskOffIterator, const LeafNode, ValueType, ValueOff >

friend struct ValueIter< MaskOffIterator, const LeafNode, ValueType, ValueOff >
| friend

## ◆ ValueIter< MaskOffIterator, LeafNode, ValueType, ValueOff >

friend struct ValueIter< MaskOffIterator, LeafNode, ValueType, ValueOff >
| friend

## ◆ ValueIter< MaskOnIterator, const LeafNode, ValueType, ValueOn >

friend struct ValueIter< MaskOnIterator, const LeafNode, ValueType, ValueOn >
| friend

## ◆ ValueIter< MaskOnIterator, LeafNode, ValueType, ValueOn >

friend struct ValueIter< MaskOnIterator, LeafNode, ValueType, ValueOn >
| friend

## Member Data Documentation

## ◆ DIM

const Index DIM = 1 << TOTAL
| static

## ◆ LEVEL

const Index LEVEL = 0
| static

## ◆ LOG2DIM

const Index LOG2DIM = Log2Dim
| static

## ◆ NUM_VALUES

const Index NUM_VALUES = 1 << 3 * Log2Dim
| static

## ◆ NUM_VOXELS

const Index NUM_VOXELS = NUM_VALUES
| static

## ◆ SIZE

const Index SIZE = NUM_VALUES
| static

## ◆ TOTAL

const Index TOTAL = Log2Dim
| static

The documentation for this class was generated from the following file:

- LeafNode.h